Subject: Re: command abbreviation

From: [email-masked] (Charles Lasner)
Date: Sat, 7 Nov 1992 03:45:45 GMT

In article <[email-masked]> [email-masked] (Daan Sandee) writes:
>In article <[email-masked]>, [email-masked] (Jay S. Rouman) writes:
>|> In article <u734120.720953366@bruny> [email-masked] (John Lamp) writes:
>|> >shades of the dreaded pip command of CP/M and DEC fame - this also was a
>|> >copy command which was pip <destination> <source>
>|> 
>|> I agree that the PIP syntax seems backwards, but in all fairness, you
>|> left out the equals sign.  It's "PIP destination = source".  It really
>|> isn't much stranger than "x = 1".
>|> -- 
>|> Jay Rouman  ([email-masked]  [email-masked])
>
>Actually, even longer ago, it was
>  pip dest <-  source
>where the left arrow was a valid character on KSR38s and other wild machines.

When I started with the PDP-10, the model 33 teletypes had a left-arrow
key and it was used as described.  But it became an under-score, and the
up-arrow became a caret.  The caret isn't too far removed from up-arrow,
so up-arrow-C and the like was still acceptable, and is usually read as
"control-C" anyway.  A print option to this effect was even called "arrow
mode".

But the underscore was unacceptable, so someone decided to use = as an 
alternate character.  Newer stuff dropped the underscore altogether, and
just use = (CP/M PIP).

Newer still systems just use <command> <input> <output> without
any separators at all, on the theory that it flows that way, so
you don't need it.  (Also some systems used = as a separator in this order
which totally confuses one who switches.)

In my proprietary system for the PDP-8 (P?S/8) I allow a dual command syntax:

.PAL BAR<FOO    or
.PAL FOO>BAR

The brackets "point" at the output side, so "FOO" is input and "BAR" is output
in both examples.  You must supply either.  IF there is no output, then:

.PAL FOO

is acceptable, but the only way to have output without input would be:

.PAL>BAR   or
.PAL BAR<

DEC's OS/8 family generally uses the .PAL BAR<FOO variety only.  Some versions
allow = as well as <.  Originally it was intended to be the back-arrow
character, but when it became underscore, this was abandoned.

cjl